
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gtkembedmoz/gtkmozembed.h>


#define TYPE_HTML_VIEWER_WINDOW (html_viewer_window_get_type ())
#define HTML_VIEWER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HTML_VIEWER_WINDOW, HtmlViewerWindow))
#define HTML_VIEWER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HTML_VIEWER_WINDOW, HtmlViewerWindowClass))
#define IS_HTML_VIEWER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HTML_VIEWER_WINDOW))
#define IS_HTML_VIEWER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HTML_VIEWER_WINDOW))
#define HTML_VIEWER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HTML_VIEWER_WINDOW, HtmlViewerWindowClass))

typedef struct _HtmlViewerWindow HtmlViewerWindow;
typedef struct _HtmlViewerWindowClass HtmlViewerWindowClass;
typedef struct _HtmlViewerWindowPrivate HtmlViewerWindowPrivate;

struct _HtmlViewerWindow {
	GtkWindow parent_instance;
	HtmlViewerWindowPrivate * priv;
};

struct _HtmlViewerWindowClass {
	GtkWindowClass parent_class;
};

struct _HtmlViewerWindowPrivate {
	GtkToolButton* _back_button;
	GtkToolButton* _forward_button;
	GtkToolButton* _quit_button;
	GtkMozEmbed* _moz;
};



extern gint param_width;
gint param_width = {0};
extern gint param_height;
gint param_height = {0};
extern char* param_title;
char* param_title = NULL;
extern char* param_url;
char* param_url = NULL;
HtmlViewerWindow* html_viewer_window_new (void);
HtmlViewerWindow* html_viewer_window_construct (GType object_type);
GType html_viewer_window_get_type (void);
void _main (char** args, int args_length1);
#define HTML_VIEWER_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_HTML_VIEWER_WINDOW, HtmlViewerWindowPrivate))
enum  {
	HTML_VIEWER_WINDOW_DUMMY_PROPERTY,
	HTML_VIEWER_WINDOW_BACK_BUTTON,
	HTML_VIEWER_WINDOW_FORWARD_BUTTON,
	HTML_VIEWER_WINDOW_QUIT_BUTTON,
	HTML_VIEWER_WINDOW_MOZ
};
void html_viewer_window_set_quit_button (HtmlViewerWindow* self, GtkToolButton* value);
void html_viewer_window_set_back_button (HtmlViewerWindow* self, GtkToolButton* value);
void html_viewer_window_set_forward_button (HtmlViewerWindow* self, GtkToolButton* value);
GtkToolButton* html_viewer_window_get_quit_button (HtmlViewerWindow* self);
GtkToolButton* html_viewer_window_get_back_button (HtmlViewerWindow* self);
GtkToolButton* html_viewer_window_get_forward_button (HtmlViewerWindow* self);
void html_viewer_window_set_moz (HtmlViewerWindow* self, GtkMozEmbed* value);
GtkMozEmbed* html_viewer_window_get_moz (HtmlViewerWindow* self);
void html_viewer_window_create_widgets (HtmlViewerWindow* self);
static void _gtk_main_quit_gtk_object_destroy (HtmlViewerWindow* _sender, gpointer self);
static void _gtk_main_quit_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self);
static void _gtk_moz_embed_go_back_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self);
static void _gtk_moz_embed_go_forward_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self);
void html_viewer_window_connect_signals (HtmlViewerWindow* self);
static void html_viewer_window_update_buttons (HtmlViewerWindow* self);
HtmlViewerWindow* html_viewer_window_new (void);
static GObject * html_viewer_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gpointer html_viewer_window_parent_class = NULL;
static void html_viewer_window_finalize (GObject* obj);
static void html_viewer_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void html_viewer_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



void _main (char** args, int args_length1) {
	char* _tmp1_;
	const char* _tmp0_;
	HtmlViewerWindow* test;
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	param_title = (_tmp1_ = (_tmp0_ = args[1], (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), param_title = (g_free (param_title), NULL), _tmp1_);
	if (_vala_strcmp0 (param_title, "--help") == 0) {
		g_print ("Usage: 'title' 'url' width height\n");
		return;
	}
	/*
	    param_url=args[2]
	
	    param_width=args[3].to_int()
	
	    param_height=args[4].to_int()
	*/
	if (_vala_strcmp0 (param_title, "") == 0) {
		char* _tmp2_;
		char* _tmp3_;
		_tmp2_ = NULL;
		param_title = (_tmp2_ = g_strdup ("HTML-viewer"), param_title = (g_free (param_title), NULL), _tmp2_);
		_tmp3_ = NULL;
		param_url = (_tmp3_ = g_strdup ("http://google.com"), param_url = (g_free (param_url), NULL), _tmp3_);
		param_width = 780;
		param_height = 540;
	}
	gtk_init (&args_length1, &args);
	test = g_object_ref_sink (html_viewer_window_new ());
	gtk_widget_show_all ((GtkWidget*) test);
	gtk_main ();
	(test == NULL) ? NULL : (test = (g_object_unref (test), NULL));
}


int main (int argc, char ** argv) {
	g_type_init ();
	_main (argv, argc);
	return 0;
}


void html_viewer_window_create_widgets (HtmlViewerWindow* self) {
	GtkToolbar* toolbar;
	GtkToolButton* _tmp0_;
	GtkToolButton* _tmp1_;
	GtkToolButton* _tmp2_;
	GtkMozEmbed* _tmp3_;
	GtkVBox* vbox;
	g_return_if_fail (self != NULL);
	toolbar = g_object_ref_sink ((GtkToolbar*) gtk_toolbar_new ());
	_tmp0_ = NULL;
	html_viewer_window_set_quit_button (self, _tmp0_ = g_object_ref_sink ((GtkToolButton*) gtk_tool_button_new_from_stock (GTK_STOCK_QUIT)));
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL));
	_tmp1_ = NULL;
	html_viewer_window_set_back_button (self, _tmp1_ = g_object_ref_sink ((GtkToolButton*) gtk_tool_button_new_from_stock (GTK_STOCK_GO_BACK)));
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_object_unref (_tmp1_), NULL));
	_tmp2_ = NULL;
	html_viewer_window_set_forward_button (self, _tmp2_ = g_object_ref_sink ((GtkToolButton*) gtk_tool_button_new_from_stock (GTK_STOCK_GO_FORWARD)));
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_object_unref (_tmp2_), NULL));
	gtk_container_add ((GtkContainer*) toolbar, (GtkWidget*) self->priv->_quit_button);
	gtk_container_add ((GtkContainer*) toolbar, (GtkWidget*) self->priv->_back_button);
	gtk_container_add ((GtkContainer*) toolbar, (GtkWidget*) self->priv->_forward_button);
	_tmp3_ = NULL;
	html_viewer_window_set_moz (self, _tmp3_ = g_object_ref_sink (gtk_moz_embed_new ()));
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_object_unref (_tmp3_), NULL));
	gtk_moz_embed_load_url (self->priv->_moz, param_url);
	vbox = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0));
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) toolbar, FALSE, TRUE, (guint) 0);
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) self->priv->_moz);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) vbox);
	(toolbar == NULL) ? NULL : (toolbar = (g_object_unref (toolbar), NULL));
	(vbox == NULL) ? NULL : (vbox = (g_object_unref (vbox), NULL));
}


static void _gtk_main_quit_gtk_object_destroy (HtmlViewerWindow* _sender, gpointer self) {
	gtk_main_quit ();
}


static void _gtk_main_quit_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self) {
	gtk_main_quit ();
}


static void _gtk_moz_embed_go_back_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self) {
	gtk_moz_embed_go_back (self);
}


static void _gtk_moz_embed_go_forward_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self) {
	gtk_moz_embed_go_forward (self);
}


void html_viewer_window_connect_signals (HtmlViewerWindow* self) {
	g_return_if_fail (self != NULL);
	g_signal_connect ((GtkObject*) self, "destroy", (GCallback) _gtk_main_quit_gtk_object_destroy, NULL);
	g_signal_connect (self->priv->_quit_button, "clicked", (GCallback) _gtk_main_quit_gtk_tool_button_clicked, NULL);
	g_signal_connect_object (self->priv->_back_button, "clicked", (GCallback) _gtk_moz_embed_go_back_gtk_tool_button_clicked, self->priv->_moz, 0);
	g_signal_connect_object (self->priv->_forward_button, "clicked", (GCallback) _gtk_moz_embed_go_forward_gtk_tool_button_clicked, self->priv->_moz, 0);
}


static void html_viewer_window_update_buttons (HtmlViewerWindow* self) {
	g_return_if_fail (self != NULL);
	g_object_set ((GtkWidget*) self->priv->_back_button, "sensitive", gtk_moz_embed_can_go_back (self->priv->_moz), NULL);
	g_object_set ((GtkWidget*) self->priv->_forward_button, "sensitive", gtk_moz_embed_can_go_forward (self->priv->_moz), NULL);
}


HtmlViewerWindow* html_viewer_window_construct (GType object_type) {
	HtmlViewerWindow * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


HtmlViewerWindow* html_viewer_window_new (void) {
	return html_viewer_window_construct (TYPE_HTML_VIEWER_WINDOW);
}


GtkToolButton* html_viewer_window_get_back_button (HtmlViewerWindow* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_back_button;
}


void html_viewer_window_set_back_button (HtmlViewerWindow* self, GtkToolButton* value) {
	g_return_if_fail (self != NULL);
	self->priv->_back_button = value;
	g_object_notify ((GObject *) self, "back-button");
}


GtkToolButton* html_viewer_window_get_forward_button (HtmlViewerWindow* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_forward_button;
}


void html_viewer_window_set_forward_button (HtmlViewerWindow* self, GtkToolButton* value) {
	g_return_if_fail (self != NULL);
	self->priv->_forward_button = value;
	g_object_notify ((GObject *) self, "forward-button");
}


GtkToolButton* html_viewer_window_get_quit_button (HtmlViewerWindow* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_quit_button;
}


void html_viewer_window_set_quit_button (HtmlViewerWindow* self, GtkToolButton* value) {
	g_return_if_fail (self != NULL);
	self->priv->_quit_button = value;
	g_object_notify ((GObject *) self, "quit-button");
}


GtkMozEmbed* html_viewer_window_get_moz (HtmlViewerWindow* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_moz;
}


void html_viewer_window_set_moz (HtmlViewerWindow* self, GtkMozEmbed* value) {
	g_return_if_fail (self != NULL);
	self->priv->_moz = value;
	g_object_notify ((GObject *) self, "moz");
}


static GObject * html_viewer_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	HtmlViewerWindowClass * klass;
	GObjectClass * parent_class;
	HtmlViewerWindow * self;
	klass = HTML_VIEWER_WINDOW_CLASS (g_type_class_peek (TYPE_HTML_VIEWER_WINDOW));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = HTML_VIEWER_WINDOW (obj);
	{
		gtk_window_set_title ((GtkWindow*) self, param_title);
		g_object_set ((GtkWindow*) self, "default-height", param_height, NULL);
		g_object_set ((GtkWindow*) self, "default-width", param_width, NULL);
		g_object_set ((GtkWindow*) self, "window-position", GTK_WIN_POS_CENTER, NULL);
		html_viewer_window_create_widgets (self);
		html_viewer_window_connect_signals (self);
	}
	return obj;
}


static void html_viewer_window_class_init (HtmlViewerWindowClass * klass) {
	html_viewer_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (HtmlViewerWindowPrivate));
	G_OBJECT_CLASS (klass)->get_property = html_viewer_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = html_viewer_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = html_viewer_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = html_viewer_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), HTML_VIEWER_WINDOW_BACK_BUTTON, g_param_spec_object ("back-button", "back-button", "back-button", GTK_TYPE_TOOL_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HTML_VIEWER_WINDOW_FORWARD_BUTTON, g_param_spec_object ("forward-button", "forward-button", "forward-button", GTK_TYPE_TOOL_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HTML_VIEWER_WINDOW_QUIT_BUTTON, g_param_spec_object ("quit-button", "quit-button", "quit-button", GTK_TYPE_TOOL_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HTML_VIEWER_WINDOW_MOZ, g_param_spec_object ("moz", "moz", "moz", GTK_TYPE_MOZ_EMBED, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void html_viewer_window_instance_init (HtmlViewerWindow * self) {
	self->priv = HTML_VIEWER_WINDOW_GET_PRIVATE (self);
}


static void html_viewer_window_finalize (GObject* obj) {
	HtmlViewerWindow * self;
	self = HTML_VIEWER_WINDOW (obj);
	G_OBJECT_CLASS (html_viewer_window_parent_class)->finalize (obj);
}


GType html_viewer_window_get_type (void) {
	static GType html_viewer_window_type_id = 0;
	if (html_viewer_window_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (HtmlViewerWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) html_viewer_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HtmlViewerWindow), 0, (GInstanceInitFunc) html_viewer_window_instance_init, NULL };
		html_viewer_window_type_id = g_type_register_static (GTK_TYPE_WINDOW, "HtmlViewerWindow", &g_define_type_info, 0);
	}
	return html_viewer_window_type_id;
}


static void html_viewer_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	HtmlViewerWindow * self;
	gpointer boxed;
	self = HTML_VIEWER_WINDOW (object);
	switch (property_id) {
		case HTML_VIEWER_WINDOW_BACK_BUTTON:
		g_value_set_object (value, html_viewer_window_get_back_button (self));
		break;
		case HTML_VIEWER_WINDOW_FORWARD_BUTTON:
		g_value_set_object (value, html_viewer_window_get_forward_button (self));
		break;
		case HTML_VIEWER_WINDOW_QUIT_BUTTON:
		g_value_set_object (value, html_viewer_window_get_quit_button (self));
		break;
		case HTML_VIEWER_WINDOW_MOZ:
		g_value_set_object (value, html_viewer_window_get_moz (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void html_viewer_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	HtmlViewerWindow * self;
	self = HTML_VIEWER_WINDOW (object);
	switch (property_id) {
		case HTML_VIEWER_WINDOW_BACK_BUTTON:
		html_viewer_window_set_back_button (self, g_value_get_object (value));
		break;
		case HTML_VIEWER_WINDOW_FORWARD_BUTTON:
		html_viewer_window_set_forward_button (self, g_value_get_object (value));
		break;
		case HTML_VIEWER_WINDOW_QUIT_BUTTON:
		html_viewer_window_set_quit_button (self, g_value_get_object (value));
		break;
		case HTML_VIEWER_WINDOW_MOZ:
		html_viewer_window_set_moz (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




